diff -Nur linux-2.4.30/drivers/ide/ide-probe.c linux-2.4.30-linux-mips.org/drivers/ide/ide-probe.c
--- linux-2.4.30/drivers/ide/ide-probe.c	2004-04-14 15:05:29.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/ide/ide-probe.c	2005-05-12 18:01:29.000000000 +0200
@@ -833,6 +833,9 @@
 #if CONFIG_BLK_DEV_PDC4030
 	    (hwif->chipset != ide_pdc4030 || hwif->channel == 0) &&
 #endif /* CONFIG_BLK_DEV_PDC4030 */
+#if CONFIG_BLK_DEV_IDE_AU1XXX
+	    (hwif->chipset != ide_au1xxx) &&
+#endif /* CONFIG_BLK_DEV_AU1XXX */
 	    (hwif_check_regions(hwif))) {
 		u16 msgout = 0;
 		for (unit = 0; unit < MAX_DRIVES; ++unit) {
diff -Nur linux-2.4.30/drivers/ide/Makefile linux-2.4.30-linux-mips.org/drivers/ide/Makefile
--- linux-2.4.30/drivers/ide/Makefile	2004-04-14 15:05:29.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/ide/Makefile	2005-05-12 18:01:29.000000000 +0200
@@ -11,14 +11,14 @@
 
 export-objs := ide-iops.o ide-taskfile.o ide-proc.o ide.o ide-probe.o ide-probe-mini.o ide-dma.o ide-lib.o setup-pci.o ide-io.o ide-disk.o
 
-all-subdirs	:= arm legacy pci ppc raid
+all-subdirs	:= arm legacy pci ppc raid au1xxx
 mod-subdirs	:= arm legacy pci ppc raid
 
 obj-y		:=
 obj-m		:=
 ide-obj-y	:=
 
-subdir-$(CONFIG_BLK_DEV_IDE) += legacy ppc arm raid pci
+subdir-$(CONFIG_BLK_DEV_IDE) += legacy ppc arm raid pci au1xxx
 
 # First come modules that register themselves with the core
 
@@ -55,6 +55,7 @@
   obj-y		+= legacy/idedriver-legacy.o
   obj-y		+= ppc/idedriver-ppc.o
   obj-y		+= arm/idedriver-arm.o
+  obj-y		+= au1xxx/au1xxx-idedriver.o
 else
   ifeq ($(CONFIG_BLK_DEV_HD_ONLY),y)
 	subdir-$(CONFIG_BLK_DEV_HD_ONLY) += legacy
diff -Nur linux-2.4.30/drivers/ide/pci/hpt366.c linux-2.4.30-linux-mips.org/drivers/ide/pci/hpt366.c
--- linux-2.4.30/drivers/ide/pci/hpt366.c	2004-08-08 01:26:04.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/ide/pci/hpt366.c	2005-05-12 18:01:30.000000000 +0200
@@ -916,8 +916,9 @@
 		did = inb(dmabase + 0x22);
 		rid = inb(dmabase + 0x28);
 	
-		if((did == 4 && rid == 6) || (did == 5 && rid > 1))
-			is_372n = 1;
+		if((did == 4 && rid == 6) || (did == 5 && rid > 1) ||
+				(did == 7 && rid == 2)) 
+			is_372n = 1; /* force 372n timing for 371n */
 	}
 		
 	/*
diff -Nur linux-2.4.30/drivers/Makefile linux-2.4.30-linux-mips.org/drivers/Makefile
--- linux-2.4.30/drivers/Makefile	2003-11-28 19:26:19.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/Makefile	2005-05-12 18:01:29.000000000 +0200
@@ -48,5 +48,6 @@
 subdir-$(CONFIG_ACPI_BOOT)	+= acpi
 
 subdir-$(CONFIG_BLUEZ)		+= bluetooth
+subdir-$(CONFIG_MMC)		+= mmc
 
 include $(TOPDIR)/Rules.make
diff -Nur linux-2.4.30/drivers/media/video/indycam.c linux-2.4.30-linux-mips.org/drivers/media/video/indycam.c
--- linux-2.4.30/drivers/media/video/indycam.c	2004-02-18 14:36:31.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/media/video/indycam.c	2005-05-12 17:57:24.000000000 +0200
@@ -50,13 +50,14 @@
 		0x80,			/* INDYCAM_GAMMA */
 	};
 
-	int err = 0;
 	struct indycam *camera;
 	struct i2c_client *client;
+	int err = 0;
 
 	client = kmalloc(sizeof(*client), GFP_KERNEL);
-	if (!client) 
+	if (!client)
 		return -ENOMEM;
+
 	camera = kmalloc(sizeof(*camera), GFP_KERNEL);
 	if (!camera) {
 		err = -ENOMEM;
@@ -67,7 +68,7 @@
 	client->adapter = adap;
 	client->addr = addr;
 	client->driver = &i2c_driver_indycam;
-	strcpy(client->name, "IndyCam client");			
+	strcpy(client->name, "IndyCam client");
 	camera->client = client;
 
 	err = i2c_attach_client(client);
@@ -75,18 +76,18 @@
 		goto out_free_camera;
 
 	camera->version = i2c_smbus_read_byte_data(client, INDYCAM_VERSION);
-	if (camera->version != CAMERA_VERSION_INDY &&
-	    camera->version != CAMERA_VERSION_MOOSE) {
+	if ((camera->version != CAMERA_VERSION_INDY) &&
+	    (camera->version != CAMERA_VERSION_MOOSE)) {
 		err = -ENODEV;
 		goto out_detach_client;
 	}
-	printk(KERN_INFO "Indycam v%d.%d detected.\n",
+	printk(KERN_INFO "IndyCam v%d.%d detected.\n",
 	       INDYCAM_VERSION_MAJOR(camera->version),
 	       INDYCAM_VERSION_MINOR(camera->version));
 
 	err = i2c_master_send(client, initseq, sizeof(initseq));
 	if (err)
-		printk(KERN_INFO "IndyCam initalization failed\n");
+		printk(KERN_ERR "IndyCam initalization failed.\n");
 
 	MOD_INC_USE_COUNT;
 	return 0;
diff -Nur linux-2.4.30/drivers/media/video/vino.c linux-2.4.30-linux-mips.org/drivers/media/video/vino.c
--- linux-2.4.30/drivers/media/video/vino.c	2004-02-18 14:36:31.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/media/video/vino.c	2005-05-12 17:57:25.000000000 +0200
@@ -5,6 +5,8 @@
  * License version 2 as published by the Free Software Foundation.
  *
  * Copyright (C) 2003 Ladislav Michl <ladis@linux-mips.org>
+ * Copyright (C) 2004 Mikael Nousiainen <tmnousia@cc.hut.fi>
+ * 
  */
 
 #include <linux/module.h>
@@ -37,13 +39,23 @@
 #define DEBUG(x...)
 #endif
 
+/* Channels (who could have guessed) */
+#define VINO_CHAN_NONE		0
+#define VINO_CHAN_A		1
+#define VINO_CHAN_B		2
+
 /* VINO video size */
 #define VINO_PAL_WIDTH		768
 #define VINO_PAL_HEIGHT		576
 #define VINO_NTSC_WIDTH		646
 #define VINO_NTSC_HEIGHT	486
 
-/* set this to some sensible values. note: VINO_MIN_WIDTH has to be 8*x */
+/* Minimum value for Y-clipping (for smaller values the images
+ * will be corrupted) */
+#define VINO_MIN_Y_CLIPPING	2
+ 
+/* Set these to some sensible values.
+ * Note: the picture width has to be divisible by 8 */
 #define VINO_MIN_WIDTH		32
 #define VINO_MIN_HEIGHT		32
 
@@ -64,9 +76,7 @@
 
 struct vino_device {
 	struct video_device vdev;
-#define VINO_CHAN_A	1
-#define VINO_CHAN_B	2
-	int chan;
+	int chan;	/* VINO_CHAN_NONE, VINO_CHAN_A or VINO_CHAN_B */
 	int alpha;
 	/* clipping... */
 	unsigned int left, right, top, bottom;
@@ -106,7 +116,7 @@
 
 struct vino_client {
 	struct i2c_client *driver;
-	int owner;
+	int owner;	/* VINO_CHAN_NONE, VINO_CHAN_A or VINO_CHAN_B */
 };
 
 struct vino_video {
@@ -362,6 +372,7 @@
 static int dma_setup(struct vino_device *v)
 {
 	u32 ctrl, intr;
+	int ofs;
 	struct sgi_vino_channel *ch;
 
 	ch = (v->chan == VINO_CHAN_A) ? &vino->a : &vino->b;
@@ -377,14 +388,24 @@
 	ch->line_size = v->line_size - 8;
 	/* set the alpha register */
 	ch->alpha = v->alpha;
-	/* set cliping registers */
-	ch->clip_start = VINO_CLIP_ODD(v->top) | VINO_CLIP_EVEN(v->top+1) |
+	/* Set the clipping registers, this is the constant source of fun :)
+	 * Y clipping start has to be >= 2 and end has to be start + height/2
+	 * The values of top and bottom are even so dividing is not a problem
+	 *
+	 * The docs say that clipping values for the even field should be
+	 * odd_end + something_to_skip_vertical_blanking + some_lines and
+	 * even_start + height/2, though the image is good this way also
+	 *
+	 * TODO: for analog sources (SAA7191), the clipping values are a bit
+	 * different and that case isn't yet handled
+	 */
+	ofs = VINO_MIN_Y_CLIPPING;	/* Should depend on input source */
+	ch->clip_start = VINO_CLIP_ODD(ofs + v->top / 2) |
+			 VINO_CLIP_EVEN(ofs + v->top / 2 + 1) |
 			 VINO_CLIP_X(v->left);
-	ch->clip_end = VINO_CLIP_ODD(v->bottom) | VINO_CLIP_EVEN(v->bottom+1) |
+	ch->clip_end = VINO_CLIP_ODD(ofs + v->bottom / 2 - 1) |
+		       VINO_CLIP_EVEN(ofs + v->bottom / 2) |
 		       VINO_CLIP_X(v->right);
-	/* FIXME: end-of-field bug workaround
-		       VINO_CLIP_X(VINO_PAL_WIDTH);
-	 */
 	/* init the frame rate and norm (full frame rate only for now...) */
 	ch->frame_rate = VINO_FRAMERT_RT(0x1fff) |
 			 (get_capture_norm(v) == VIDEO_MODE_PAL ?
@@ -510,6 +531,7 @@
 static void vino_interrupt(int irq, void *dev_id, struct pt_regs *regs)
 {
 	u32 intr, ctrl;
+	int a_eof, b_eof;
 
 	spin_lock(&Vino->vino_lock);
 	ctrl = vino->control;
@@ -525,12 +547,14 @@
 		vino->control = ctrl;
 		clear_eod(&Vino->chB);
 	}
+	a_eof = intr & VINO_INTSTAT_A_EOF;
+	b_eof = intr & VINO_INTSTAT_B_EOF;
 	vino->intr_status = ~intr;
 	spin_unlock(&Vino->vino_lock);
-	/* FIXME: For now we are assuming that interrupt means that frame is
-	 * done. That's not true, but we can live with such brokeness for
-	 * a while ;-) */
-	field_done(&Vino->chA);
+	if (a_eof)
+		field_done(&Vino->chA);
+	if (b_eof)
+		field_done(&Vino->chB);
 }
 
 static int vino_grab(struct vino_device *v, int frame)
diff -Nur linux-2.4.30/drivers/mmc/Config.in linux-2.4.30-linux-mips.org/drivers/mmc/Config.in
--- linux-2.4.30/drivers/mmc/Config.in	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/mmc/Config.in	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,19 @@
+#
+# MMC subsystem configuration
+#
+mainmenu_option next_comment
+comment 'MMC/SD Card support'
+
+tristate 'MMC support' CONFIG_MMC
+if [ "$CONFIG_MMC" = "y" -o "$CONFIG_MMC" = "m" ]; then
+  bool '  MMC debugging' CONFIG_MMC_DEBUG
+  if [ "$CONFIG_MMC_DEBUG" = "y" ]; then
+    int '  MMC debugging verbosity (0=quiet, 3=noisy)' CONFIG_MMC_DEBUG_VERBOSE 0
+  fi
+fi
+
+  if [ "$CONFIG_SOC_AU1100" = "y" -o "$CONFIG_SOC_AU1200" = "y" ]; then
+    dep_tristate 'Au1100/Au1200 MMC/SD Card support' CONFIG_MMC_AU1100 $CONFIG_MMC
+  fi
+
+endmenu
diff -Nur linux-2.4.30/drivers/mmc/Makefile linux-2.4.30-linux-mips.org/drivers/mmc/Makefile
--- linux-2.4.30/drivers/mmc/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/mmc/Makefile	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,21 @@
+#
+# Makefile for the kernel mmc device drivers.
+#
+
+O_TARGET := mmc.o
+
+export-objs := mmc_core.o mmc_media.o
+
+obj-$(CONFIG_MMC) += mmc_base.o
+obj-$(CONFIG_MMC_AU1100) += mmc_au1x.o
+
+# Declare multi-part drivers.
+list-multi := mmc_base.o
+mmc_base-objs := mmc_protocol.o mmc_core.o mmc_media.o
+
+include $(TOPDIR)/Rules.make
+
+# Link rules for multi-part drivers.
+
+mmc_base.o: $(mmc_base-objs)
+	$(LD) -r -o $@ $(mmc_base-objs)
